changeset 7176:4c4e077627c0

A help2man wrapper script that avoids breaking the build in various situations.
author Bruno Haible <bruno@clisp.org>
date Tue, 22 Aug 2006 12:17:43 +0000
parents c0a554faf219
children b15c5c1d9094
files ChangeLog build-aux/x-to-1.in
diffstat 2 files changed, 64 insertions(+), 0 deletions(-) [+]
line wrap: on
line diff
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,7 @@
+2006-08-22  Bruno Haible <bruno@clisp.org>
+
+	* build-aux/x-to-1.in: New file, from GNU gettext.
+
 2006-08-22  Simon Josefsson  <jas@extundo.com>
 
 	* modules/gc-md5 (Makefile.am): Need to add md5.h, after changes
new file mode 100644
--- /dev/null
+++ b/build-aux/x-to-1.in
@@ -0,0 +1,60 @@
+#! /bin/sh
+#
+# Copyright (C) 2001, 2003 Free Software Foundation, Inc.
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2, or (at your option)
+# any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software Foundation,
+# Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
+#
+
+# This program creates a program's manual from the .x skeleton and its --help
+# output.
+
+update=
+while true; do
+  case "$1" in
+    --update) update=yes; shift;;
+    *) break;;
+  esac
+done
+
+if test $# != 5; then
+  echo "Usage: x-to-1 [OPTIONS] PERL HELP2MAN executable program.x program.1" 1>&2
+  exit 1
+fi
+PERL="$1"
+HELP2MAN="$2"
+executable="$3"
+aux="$4"
+output="$5"
+
+progname=`basename $aux .x`
+case "$PERL" in *"/missing perl") perlok=no;; *) perlok=yes;; esac
+if test @CROSS_COMPILING@ = no && test -f $executable && test $perlok = yes; then
+  echo "Updating man page $output"
+  echo "$HELP2MAN --include=$aux $executable > $output"
+  rm -f t-$progname.1
+  $HELP2MAN --include=$aux $executable > t-$progname.1 || exit 1
+  if test -n "$update"; then
+    # In --update mode, don't overwrite the output if nothing would change.
+    if cmp t-$progname.1 $output >/dev/null 2>&1; then
+      rm -f t-$progname.1
+    else
+      mv t-$progname.1 $output
+    fi
+  else
+    mv t-$progname.1 $output
+  fi
+else
+  echo "WARNING: The man page $output cannot be updated yet."
+fi